using System;
using System.Collections.Generic;
using nToolbox;
using nToolbox.Collections;
using NUnit.Framework;

namespace nToolbox.Core.Test.Collections
{
	[TestFixture]
	public class TestListMap
	{
		ListMap<long, int> map;
		
		[SetUp]
		public void Setup()
		{
			map = new ListMap<long, int>();
			map.Add(1, 2);
			map.Add(1, 3);
			map.Add(2, 2);
		}

		[Test]
		public void Add()
		{
			Assert.AreEqual(2, map.Count);
			map.Add(1, 4);
			Assert.AreEqual(2, map.Count);
			map.Add(3, 7);
			Assert.AreEqual(3, map.Count);
		}
		
		[Test]
		public void Get()
		{
			Assert.AreEqual(2,map.Get(1).Count);
			Assert.IsNull(map.Get(4));
		}
		
		[Test]
		public void Remove()
		{
			Assert.IsFalse(map.RemoveAll(7));
			Assert.IsTrue(map.RemoveAll(1));
			Assert.AreEqual(1, map.Count);
		}
		
		[Test]
		public void Clear()
		{
			map.Clear();
			Assert.AreEqual(0, map.Count);
		}
		
		[Test]
		public void TryGetValue()
		{
			IList<int> list;
			Assert.IsTrue(map.TryGetValue(1, out list));
			Assert.IsFalse(map.TryGetValue(7, out list));
		}
	}
}
