using System;
using nToolbox.Data.SQLServer;
using NUnit.Framework;

namespace nToolbox.Core.Test.Data.SQLServer
{
    [TestFixture]
    public class TestSQLServerInformation
    {
        private readonly string ServerName = "test";
        private readonly bool IsClustered = true;
        private readonly string InstanceName = "instance";
        private readonly string Version = "2005";

        [Test]
        public void TestServerName()
        {
            SQLServerInformation ssi = new SQLServerInformation();
            ssi.ServerName = ServerName;
            Assert.AreEqual(ServerName, ssi.ServerName);
        }

        [Test]
        public void TestIsClustered()
        {
            SQLServerInformation ssi = new SQLServerInformation();
            ssi.IsClustered = IsClustered;
            Assert.AreEqual(IsClustered, ssi.IsClustered);
        }

        [Test]
        public void TestInstanceName()
        {
            SQLServerInformation ssi = new SQLServerInformation();
            ssi.InstanceName = InstanceName;
            Assert.AreEqual(InstanceName, ssi.InstanceName);
        }

        [Test]
        public void TestVersion()
        {
            SQLServerInformation ssi = new SQLServerInformation();
            ssi.Version = Version;
            Assert.AreEqual(Version, ssi.Version);
        }

        [Test]
        public void TestConstructor()
        {
            //Default constructor
            SQLServerInformation info1 = new SQLServerInformation();    
            Assert.IsNotNull(info1);

            //Short contructor
            SQLServerInformation info2 = new SQLServerInformation(ServerName);
            Assert.AreEqual(ServerName, info2.ServerName);
            Assert.AreEqual(string.Empty, info2.InstanceName);
            Assert.AreEqual(string.Empty, info2.Version);
            Assert.AreEqual(false, info2.IsClustered);

            //Long constructor
            SQLServerInformation info3 = new SQLServerInformation(ServerName, InstanceName, IsClustered, Version);
            Assert.AreEqual(ServerName, info3.ServerName);
            Assert.AreEqual(InstanceName, info3.InstanceName);
            Assert.AreEqual(Version, info3.Version);
            Assert.AreEqual(IsClustered, info3.IsClustered);
        }
    }
}
