using System;
using nToolbox.IO;
using NUnit.Framework;

namespace nToolbox.Core.Test.IO
{
	[TestFixture]
	public class TestCommandArguments
	{
		[Test]
		public void TestConstructor()
		{
			CommandArguments testTarget = new CommandArguments(GetTestArgs());
			Assert.AreEqual(9, testTarget.Arguments.Count);
			Assert.AreEqual("b", testTarget.Arguments["a"]);
			Assert.AreEqual("d", testTarget.Arguments["c"]);
			Assert.AreEqual("1", testTarget.Arguments["e"]);
			Assert.AreEqual("2", testTarget.Arguments["f"]);
			Assert.AreEqual(string.Empty, testTarget.Arguments["verbose"]);
			Assert.AreEqual("one", testTarget.Arguments["g"]);
			Assert.AreEqual("two", testTarget.Arguments["h"]);
			Assert.AreEqual("three", testTarget.Arguments["i"]);
			Assert.AreEqual("replace", testTarget.Arguments["j"]);
			Assert.AreEqual(null, testTarget.Arguments["doesnotexist"]);
		}

		[Test]
		public void TestAccessor()
		{
			CommandArguments testTarget = new CommandArguments(GetTestArgs());
			Assert.AreEqual(string.Empty, testTarget.Arguments["verbose"]);
			Assert.AreEqual("one", testTarget["g"]);
			Assert.AreEqual("two", testTarget["h"]);
			Assert.AreEqual("three", testTarget["i"]);
			Assert.AreEqual("replace", testTarget["j"]);
			Assert.AreEqual(string.Empty, testTarget["doesnotexist"]);
		}

		private static string[] GetTestArgs()
		{
			return
				new string[]
					{
						"-a=b", "/c:d", "-e=1", "/f:2", "/verbose", "-g='one'", "/h=\"two\"", "-i:'three'", "/j='four'", "jkl:=3993",
						"/j=replace"
					};
		}
	}
}