using System;
using System.Collections.Generic;
using NUnit.Framework;

namespace nToolbox.Core.Test
{
	[TestFixture]
	public class TestMathHelper
	{
		[Test]
		public void TestMedianValue()
		{
			Assert.AreEqual(0, MathHelper.MedianValue(new List<int>()));
			Assert.AreEqual(250, MathHelper.MedianValue(ConvertNumbersToList(250)));
			Assert.AreEqual(2, MathHelper.MedianValue(ConvertNumbersToList(1, 3, 2)));
			Assert.AreEqual(2.5, MathHelper.MedianValue(ConvertNumbersToList(1, 3, 2, 4)));
			Assert.AreEqual(7, MathHelper.MedianValue(ConvertNumbersToList(6, 7, 7, 7, 7, 7, 39)));
			Assert.AreEqual(24.5,
			                MathHelper.MedianValue(ConvertNumbersToList(31, 5, 27, 12, 114, 124, 238, 223, 22, 12, 14, 1, 18, 56)));
		}

		/// <summary>
		/// Helper function
		/// </summary>
		private static List<int> ConvertNumbersToList(params int[] args)
		{
			List<int> l = new List<int>();

			foreach (int item in args)
				l.Add(item);

			return l;
		}
	}
}